/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
	"fmt"
)

// ReportGroupBy the model 'ReportGroupBy'
type ReportGroupBy string

// List of ReportGroupBy
const (
	GroupByInteractionId ReportGroupBy = "interaction_id"
	GroupByInteractionName ReportGroupBy = "interaction_name"
	GroupByChannelId ReportGroupBy = "channel_id"
	GroupByChannelName ReportGroupBy = "channel_name"
	GroupByEntryPointId ReportGroupBy = "entry_point_id"
	GroupByLocationId ReportGroupBy = "location_id"
	GroupByLocationName ReportGroupBy = "location_name"
	GroupByMessenger ReportGroupBy = "messenger"
	GroupByTriggerType ReportGroupBy = "trigger_type"
	GroupByEntryType ReportGroupBy = "entry_type"
	GroupByLanguage ReportGroupBy = "language"
	GroupByBrowserName ReportGroupBy = "browser_name"
	GroupByDeviceName ReportGroupBy = "device_name"
	GroupByCountryCode ReportGroupBy = "country_code"
	GroupBySegments ReportGroupBy = "segments"
	GroupByLabels ReportGroupBy = "labels"
	GroupByYear ReportGroupBy = "year"
	GroupByMonth ReportGroupBy = "month"
	GroupByCalendarWeek ReportGroupBy = "calendar_week"
	GroupByDate ReportGroupBy = "date"
	GroupByDay ReportGroupBy = "day"
	GroupByHour ReportGroupBy = "hour"
	GroupByWeekDay ReportGroupBy = "week_day"
	GroupByVersion ReportGroupBy = "version"
)

// All allowed values of ReportGroupBy enum
var AllowedReportGroupByEnumValues = []ReportGroupBy{
	"interaction_id",
	"interaction_name",
	"channel_id",
	"channel_name",
	"entry_point_id",
	"location_id",
	"location_name",
	"messenger",
	"trigger_type",
	"entry_type",
	"language",
	"browser_name",
	"device_name",
	"country_code",
	"segments",
	"labels",
	"year",
	"month",
	"calendar_week",
	"date",
	"day",
	"hour",
	"week_day",
	"version",
}

func (v *ReportGroupBy) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := ReportGroupBy(value)
	for _, existing := range AllowedReportGroupByEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid ReportGroupBy", value)
}

// NewReportGroupByFromValue returns a pointer to a valid ReportGroupBy
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewReportGroupByFromValue(v string) (*ReportGroupBy, error) {
	ev := ReportGroupBy(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for ReportGroupBy: valid values are %v", v, AllowedReportGroupByEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v ReportGroupBy) IsValid() bool {
	for _, existing := range AllowedReportGroupByEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to ReportGroupBy value
func (v ReportGroupBy) Ptr() *ReportGroupBy {
	return &v
}

type NullableReportGroupBy struct {
	value *ReportGroupBy
	isSet bool
}

func (v NullableReportGroupBy) Get() *ReportGroupBy {
	return v.value
}

func (v *NullableReportGroupBy) Set(val *ReportGroupBy) {
	v.value = val
	v.isSet = true
}

func (v NullableReportGroupBy) IsSet() bool {
	return v.isSet
}

func (v *NullableReportGroupBy) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableReportGroupBy(val *ReportGroupBy) *NullableReportGroupBy {
	return &NullableReportGroupBy{value: val, isSet: true}
}

func (v NullableReportGroupBy) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableReportGroupBy) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

